Feature: Server for MineSweeper game
 I want to make a server class, that will handle the clients
 Because I love to play this game with my friends
 The used gametable for the test game in the last scenario is:
    | 0 1 2 3
  ------------
  0 | 1 1 1 0
  1 | 1 9 2 1
  2 | 2 2 3 9
  3 | 1 9 2 1
  
 Scenario: Server dump
  Given I start the server
  And I created a socket and connect to the server
  And I get the dump message from server
  Then we will get { started , 1 clients }
  
 Scenario: Disconnect
  Given I start the server
  And I created a socket and connect to the server
  And I get the dump message from server
  And I send <exit#> to the server
  And I get the dump message from server
  Then we will get { started , 0 clients }
  
 Scenario: Client unexpectedly close the socket
  Given I start the server
  And I created a socket and connect to the server
  And I close the socket without a message to server
  And I get the dump message from server
  Then we will get { started , 0 clients }
  
  
 Scenario Outline: Tipical slice from the server's life
  Given I start the server
  And I do the specified <servercmd> and <command(a,b,c,d)>
  Then we will see <state(a,b,c,d)>, <serverstate>, <point(a,b)>, <ablast> and <globallast> equal to the specified
  
  Examples:
  | servercmd | command(a,b,c,d)                     | state(a,b,c,d)                            | serverstate          | point(a,b) | ablast | globallast     |
  | dump      | {-,-,-,-,}                           | {notinlife,notinlife,notinlife,notinlife} | {started, 0 clients} | {-,-}      | -      | -              |
  | dump      | {connect,-,-,-}                      | {connected,notinlife,notinlife,notinlife} | {started, 1 clients} | {-,-}      | -      | -              |
  | dump      | {login#A,connect,-,-}                | {avaliable,connected,notinlife,notinlife} | {started, 2 clients} | {-,-}      | -      | -              |
  | dump      | {-,login#B,connect,-}                | {avaliable,avaliable,connected,notinlife} | {started, 3 clients} | {-,-}      | -      | -              |
  | dump      | {-,-,login#C,connect}                | {avaliable,avaliable,avaliable,connected} | {started, 4 clients} | {-,-}      | -      | -              |
  | dump      | {-,-,-,login#A}                      | {avaliable,avaliable,avaliable,connected} | {started, 4 clients} | {-,-}      | -      | -              |
  | dump      | {-,-,-,login#D}                      | {avaliable,avaliable,avaliable,avaliable} | {started, 4 clients} | {-,-}      | -      | -              |
  | dump      | {request#game#C,-,game#reject#A,-}   | {avaliable,avaliable,avaliable,avaliable} | {started, 4 clients} | {-,-}      | -      | -              |
  | dump      | {request#game#B,game#accept#A,-,-}   | {ingame#B,ingame#A,avaliable,avaliable}   | {started, 4 clients} | {0,0}      | -      | -              |
  | dump      | {hit#B#1#1,msg#A#Hi,globmsg#Hello,-} | {ingame#B,ingame#A,avaliable,avaliable}   | {started, 4 clients} | {1,0}      | B->Hi  | C->Hello       |
  | dump      | {hit#B#0#0,-,-,globmsg#Hi C!}        | {ingame#B,ingame#A,avaliable,avaliable}   | {started, 4 clients} | {1,0}      | B->Hi  | D->Hi C!       |
  | dump      | {-,hit#A#2#3,-,-}                    | {ingame#B,ingame#A,avaliable,avaliable}   | {started, 4 clients} | {1,1}      | B->Hi  | D->Hi C!       |
  | dump      | {-,hit#A#3#1,-,-}                    | {avaliable,avaliable,avaliable,avaliable} | {started, 4 clients} | {1,2}      | B->Hi  | D->Hi C!       |
  | msg#Hello | {-,-,-,-}                            | {avaliable,avaliable,avaliable,avaliable} | {started, 4 clients} | {-,-}      | -      | Server->Hello  |
  | dump      | {-,-,logout#,-}                      | {avaliable,avaliable,connected,avaliable} | {started, 4 clients} | {-,-}      | -      | Server->Hello  | 
  | stop      | {-,-,-,-}                            | {notinlife,notinlife,notinlife,notinlife} | {stopped, 0 clients} | {-,-}      | -      | Server->Closed |