
begin require 'rspec/expectations'; rescue LoadError; require 'spec/expectations'; end 
require 'cucumber/formatter/unicode'
$:.unshift(File.dirname(__FILE__) + '/../../lib')

require 'MineSweeperUtilModule'
require 'thread'
require 'MineSweeperGUIModule'

Given /^I call start\(true\) to the MS1 and start\(false\) to MS2$/ do
  @MS1 = nil
  @MS2 = nil
  @MS1 = MineSweeperUtilModule::MineSweeperGame.new
  @MS2 = MineSweeperUtilModule::MineSweeperGame.new
  @MS1.start(true)
  @MS2.start(false)
end

When /^I call isStarted method for MS1 and MS2$/ do
  @Result = []
  @Result << @MS1.isStarted
  @Result << @MS2.isStarted
end

Then /^I will see \[true,true\]$/ do
  @Result.should == [true,true]
end

Given /^I call setTable\(table,size\) method of MS$/ do
  @Table = MineSweeperUtilModule::Utils.TableToString(MineSweeperUtilModule::Utils.generate(16,51),false)
  @MS = MineSweeperUtilModule::MineSweeperGame.new
  @MS.setTable(@Table,16)
end

When /^I call getTable method of MS$/ do
  @Result = nil
  @Result = @MS.getTable
end

Then /^I will see 'table'$/ do
  @Result.should == @Table
end


When /^I call getTableWithMask method of MS$/ do
  @Table = nil
  @Table = @MS.getTableWithMask
end

Then /^I will see a lot of 'X'$/ do
  @Table.count('X') == 16**2
end


Given /^I call setTable\( (\d+) ,size\) method of MS$/ do |arg1|
  @MS = MineSweeperUtilModule::MineSweeperGame.new
  @MS.setTable( arg1 ,4)
end

Given /^When I call start\(true\) method of MS$/ do
  @MS.start(true)
end

Given /^When I call hit\( (\d+) , (\d+) \)$/ do |arg1, arg2|
  @MS.hit(arg1.to_i,arg2.to_i)
end

Then /^I will see the unhidden cells between 'X'\-es in ([0-9X]*)$/ do |arg1|
  @Result = @MS.getTableWithMask
  @Result.should == arg1
end