begin require 'rspec/expectations'; rescue LoadError; require 'spec/expectations'; end 
require 'cucumber/formatter/unicode'
$:.unshift(File.dirname(__FILE__) + '/../../lib')

require 'rubygems'
require 'thread'
require 'MineSweeperConnectionModule'
require 'MinimalClient.rb'


Given /^I start the server$/ do
 if (@@Srv.nil?)
  @@Srv = MineSweeperConnectionModule::MineSweeperServer.new
  Thread.new {
   @@Srv.init
   @@Srv.run 
  }

  while (!@@Srv.isStarted)
   sleep 0.1
  end
 end
end

Given /^I created a socket and connect to the server$/ do
 @@cli.stop rescue nil
 @@cli = nil
 @@cli = MinimalClient.new
 @@cli.start("")
end

Given /^I stop the server$/ do
  @@Srv.stop
end


Given /^I get the dump message from server$/ do
  sleep 0.01
  @@dump = @@Srv.dump
end
Then /^we will get \{ ([a-zA-Z0-9]*) , (\d+) clients \}$/ do |arg1, arg2|
  @@dump[0].should == arg1 and @@dump[1].should == arg2.to_i
end

Given /^I send <(.*)> to the server$/ do |arg1|
 @@cli.send(arg1)
end

Given /^I close the socket without a message to server$/ do
  @@cli.stop rescue nil
end


def handleCommand(nick,cmd)
 if (cmd.eql?('connect')) then @@clients[nick].client = MinimalClient.new; @@clients[nick].client.start(nick); end
 if (cmd.match('^login#') or cmd.match('^logout#') or cmd.match('^hit#') or cmd.match('^msg#') or cmd.match('^globmsg#') or cmd.match('^request#') or cmd.match('^game#'))
  @@clients[nick].client.send(cmd) 
 end
end


Given /^I do the specified (.*) and \{(.*),(.*),(.*),(.*)\}$/ do |srvcmd,acmd,bcmd,ccmd,dcmd|
 if (srvcmd.eql?('stop')) then @@Srv.stop; end
 if (srvcmd.match('^msg#'))
  tmp = srvcmd.split('#')
  tmp.shift
  @@Srv.sendAll(tmp.join('#'))
 end
 handleCommand('A',acmd)
 handleCommand('B',bcmd)
 handleCommand('C',ccmd)
 handleCommand('D',dcmd)
 sleep 0.1
 @@dump = @@Srv.dump
end

def tmpstate(nick)
 tmpstate = @@clients[nick].client.nil? ? "notinlife" : (@@clients[nick].client.closed? ? "notinlife" : "connected")
 if (tmpstate.eql?('connected'))
  msg = @@Srv.state(nick);
  if (msg.eql?('avaliable') or msg.match('^ingame#*')) then tmpstate = msg end
 end
 tmpstate
end

def globchat(nick,globlast)
 tmp = @@clients[nick].client.GlobChat rescue tmp = globlast
 if tmp.eql?("") then tmp = globlast end
 tmp
end


Then /^we will see \{(.*),(.*),(.*),(.*)\}, \{(\w*), (\d+) clients\}, \{([-0-9]+),([-0-9]+)\}, (.*) and (.*) equal to the specified$/ do |astate,bstate,cstate,dstate,srvstate,srvcount,apoint,bpoint,ablast,globlast|
 @states = []
 @globs = []
 ('A'..'D').each { |x| @globs << globchat(x,globlast); @states << tmpstate(x)}
 acli = @@clients['A'].client
 bcli = @@clients['B'].client
 abchata = (!acli.nil?) ? acli.getRoomLast('B') : "-"
 abchatb = (!bcli.nil?) ? bcli.getRoomLast('A') : "-"
 if (abchata.eql?("")) then abchata = "-" end
 if (abchatb.eql?("")) then abchatb = "-" end
 tmpapoint = acli.getScore('B') rescue tmpapoint = "-"
 tmpbpoint = bcli.getScore('A') rescue tmpbpoint = "-"
 @@dump[0].should == srvstate and 
 @@dump[1].should == srvcount.to_i and 
 @states[0].should == astate and 
 @states[1].should == bstate and 
 @states[2].should == cstate and 
 @states[3].should == dstate and 
 tmpapoint.should == apoint and 
 tmpbpoint.should == bpoint and
 @globs[0].should == @globs[1] and 
 @globs[1].should == @globs[2] and  
 @globs[2].should == @globs[3] and 
 @globs[3].should == @globs[1] and 
 @globs[0].should == globlast and 
 abchata.should == abchatb and 
 abchatb.should == ablast
end