require 'rubygems'
require 'thread'
require 'socket'
require 'MineSweeperUtilModule'
require 'MineSweeperConnectionModule'
require 'SocketPackets'

include Socket::Constants

class MinimalClient
 GameData = Struct.new(:game,:chat,:score,:oppscore)
 attr_reader :name
 attr_reader :GlobChat
 def start(name)
   @name = name
   @mutex = Mutex.new
   @buffer = ""
   @opponents = []
   @Table = Hash.new
   @GlobChat = ""
   @sock = Socket.new(AF_INET,SOCK_STREAM,0)
   sockaddr = "127.0.0.1:42424"
   @host,@port = sockaddr.split(":")
   sockaddr = Socket.sockaddr_in(@port,@host)
   hiba = true
   while (hiba)
    @sock.connect_nonblock(sockaddr) rescue nil
    hiba = false
   end
   @eof = false
   @thread = Thread.new {
    loop do
      @mutex.lock
      ret = IO::select([@sock],nil,nil,0.3)
      unless ret.nil?
        if @sock.eof?
          @sock.close
          @sock = nil
          @mutex.unlock
		  @thread.exit
          break
        end
        msg = @sock.recv_packet()
        @buffer += msg
        loop do
          at = @buffer.index("\n")
          if at.nil?
            break
          end
          data = @buffer[0..at-1]
          @buffer = @buffer[at+1..-1]
          parse_message(data)
        end
      end
      @mutex.unlock
    end
   }
 end
 
  def parse_message(msg)
   if (msg.match('^shutdown#*')) then @sock.close; @sock = nil; end
   if (msg.match('^globmsg#*'))
    data = msg.split('#')
	data.shift
	@GlobChat = data[0] + "->"
	data.shift
	@GlobChat += data.join('#')
   end
   if (msg.match('^msg#'))
    data = msg.split('#')
	data.shift
	opp = data.shift
	sender = data.shift
	tmp = data.join('#')
	@Table[opp].chat = sender + "->" + tmp
   end
   if (msg.match('^game#reject#*')) then  end
   if (msg.match('^table#*')) 
    data = msg.split('#')
    @opponents << data[1];
	red = data[2].eql?('1') ? true : false 
	@Table[data[1]] = GameData.new(MineSweeperUtilModule::MineSweeperGame.new(opp),"",0,0)
	@Table[data[1]].game.setTable("1110192122391921",4)
    @Table[data[1]].game.start(red)
   end
   if (msg.match('^win#*')) then end
   if (msg.match('^hit#*'))
    data = msg.split('#')
    opp = data[1]
    @Table[opp].game.hit(data[2].to_i,data[3].to_i)
	@Table[opp].score = @Table[opp].game.score
	@Table[opp].oppscore = @Table[opp].game.oppscore
	if (@Table[opp].game.state.eql?('loose'))
	 @sock.send_packet("game#lost##{opp}##{@Table[opp].game.score}##{@Table[opp].game.oppscore}")
	end
	if (@Table[opp].game.state.eql?('loose') or @Table[opp].game.state.eql?('win'))
	 @opponents.delete(opp)
	end
   end
  end
  
 def getOpponents
  @opponents
 end
 
 def getRoomLast(opp)
  if (!@Table[opp].nil?) 
   tmp = @Table[opp].chat
   if (@Table[opp].game.state.eql?("ingame"))
    return tmp
   else
    @Table[opp].chat = ""
    return tmp
   end
  end
  ""
 end
 
 def send(msg)
  @mutex.lock
  @sock.send_packet(msg)
  @mutex.unlock
 end
 
 def stop
  @mutex.lock
   @sock.close unless @sock.nil?
  @mutex.unlock
 end
 
 def closed?
  @sock.nil? ? true : @sock.closed?
 end
 
 def getScore(opp)
  if (@Table.has_key?(opp))
   if (@Table[opp].game.state.eql?("ingame") or !@Table[opp].score.nil?)
    tmp = @Table[opp].score
	@Table[opp].score = nil
	@Table[opp].oppscore = nil
    return tmp.to_s
   else
    return "-"
   end
  else
   return "-"
  end
 end
 def inGame(opp)
  !(@opponents.index { |x| x.eql?(opp) }).nil?
 end
 
end
